<?php


/*
Plugin Name: WpTweetBomb
Plugin URI: http://WpTweetBomb.com
Description: WPTB posts great content to any blog, scoops up traffic from Twitter & Google then monetizes it for you with automatic affiliate ads.
Version: 1.6.9.6
Author: Andy Baker
Author URI: http://WpTweetBomb.com
*/


/*
# PLUGIN INFORMATION
* This is a premium, paid plugin from http://WpTweetBomb.com and is not to be shared with anyone.
* It is for personal use on domains that you own.


# CONTACT INFORMATION
* If you find any bugs, weirdness or have feature requests then please post in the support forum:
* http://codex.bz/support/


# DISCLAIMER
* THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.


# Included Works
* 
* 		Twitter Icon					http://www.blogperfume.com/
* 		Other 32x32 icons			http://www.everaldo.com
* 		Handful of 16x16 icons		http://www.famfamfam.com/lab/icons/silk/
* 		SuperBox						http://www.pierrebertet.net
* 		DarkGlass Icons				http://www.mentalrey.it/icons.html


# CHANGELOG


Version 1.6.9.6 - 19th September 2011
		Repaired Twitter trends collection
		Made extra image local again

Version 1.6.9.5 - 9th August 2011
		"NoNodes" issues for article dirs fixed
		All other content sources checked and working
		Google images now work again

Version 1.6.9.4 - 5th June 2011
		Fixed Google News
		Fixed Google Blog Search
		Fixed Yahoo News
		Fixed Ezine Articles
		Fixed Digg

Version 1.6.9.3 - 30th April 2011
		Upgraded tweeting for Twitter updates
		Revamped error reporting for Twitter updates
		Sidebar ads will now show up fine on all blogs

Version 1.6.9.2 - 11th March 2011
		Fixed an error message realting to IP counts
		added CURLOPT_SSL_VERIFYPEER for Twitter calls for no errors on some (Win?) boxes.

Version 1.6.9.1 - 3rd March 2011
		Added option to turn off the power bar.

Version 1.6.9 - 2nd March 2011
		Fixed a wptb_opt file include error for some people
		Silenced the wtb_opt repairs in case you haven't got mysql permissions
		Fixed a repeated tweet cookie permissions error on very restrictive shared servers
		Fixed a randIP issue resulting in "No licence servers could be contacted" (even though they were).
		Tweet 404 error logged properly now.
		Also tweet 404 error is fixed :)
		Cleared up some more artifacts from post content ("related Posts" text etc)
		Health check done on all content sources.
		Article dirs + Digg updated.

Version 1.6.8 - 16th December 2010
		Single keystroke tweet fix (httpS)
		Improved tweet error reporting (No more "Unknown" errors)
		Updated back end Tweet debugger
		Fixed a logic error for HTTP proxies

Version 1.6.7 - 2nd December 2010
		Small update to the blog optimizer
		Added error prompt when the plugin folder isn't named correctly
		Fixed tweet error some people were seeing (Tweeting should be 30% less "heavy" too)

Version 1.6.6 - 25th November 2010
		Fixed "Unknown login error" some of your were seeing.
		Affiliate tab updated.

Version 1.6.5 - 24th November 2010
		Ads tab disappeared. Now it's back.

Version 1.6.4 - 14th August 2010
		Fixed small bug for external tweets
		Wrapped simple_html_dom with !function_exists checks
		Added an ioncube tester script (zipped in plugin folder)
		Slightly improved ioncibe error handling
		wtb_get_aff_ads() bug fixed for power bar display
		Fixed various Undefined variable notices
		Changed \' to ' in external tweets
		External tweeting has resumed (fingers crossed...)
		External tweets now work with no content blocks

Version 1.6.3 - 20th July 2010
		Fix a conflict error in the ad manager

Version 1.6.2 - 20th July 2010
		Added extra shell_exec checks to ensure no errors on restricted hosts
		Updated feed to show new forum
		Better error reporting for "ERROR: Unknown login error", plus html dump via email when it happens
		Fixed PHP warning about array_merge for ad blocks
		Extensive file include optimization for decreased resource usage
		Keyword usage optimizations, plus useful confirmation boxes.
		Index management tweet count lowered from 20 to 10, to help with resource usage.
		Tweaked PR updating functions
		Added configurable external tweet time limit (used to be forced)
		Popup warning about using more than 300 Twitter accounts
		Feed Finder one-click add links fixed
		There's now a Domain Blacklist to exclude certain domain(s)
		Extended log feedback about external tweets
		Added variable to use in ad format for tracking posts through ClickBank

Version 1.6.1 - 25th June 2010
		Several include file optimizations to lower memory usage
		Fixed small bug where tweets weren't made for demo posts
		Tweet mechanism externalised for external tweets to spread mem usage
		Added a detailed debug output for the proxy checker

Version 1.6 - 22nd June 2010
		Now we don't try to follow Twitter's "jobs" page
		Add class check for Snoopy as it was interfering with WPTB (other plugin conflict)
		Keywords used for auto category creation are now auto-capitalised (Each Word Like This)
		Posts now have a valid author (main account)
		Checks for Windows hosting and shows error
		Added a WPTB cookie for more flexible web requests
		All tweets are now handled "via web" for increased flexibility
		Content extraction is boosted by WPTB servers - meaning better content
		Compatibility with 2 backup licence/content servers for increased redundancy
		Use post title to get post tags - not content (more accurate)
		Don't let content blocks be created without a name (JS popup)
		Add special ioncube check, and give a pretty error with instructions so whole site isn't offline with ioncube error
		External tweets now correctly include bit.ly link
		If you choose to remove links, emails are now also removed
		Proxy functions have been re-coded for more reliability
		Proxy checker added to the test center
		Custom RSS handling class now used - Magpie is gone
		Editable cron password implemented for added security
		Tweets are now not made when posts set to "draft"
		Converted &apos; to ' for better visuals in IE7

Version 1.5.9.1 - 27th March 2010
		Stopped removing your Twitter account when other's accounts were blocked
		Added a bulk content block viewer when you've got more than 200 blocks

Version 1.5.9 - 23rd March 2010
		Stopped ads showing on pages
		Add premade template during blog setup
		Changed a div name that interfered with another plugin
		Improved error reporting for "Poor Content" issues. 5 separate errors will now be shown.
		You can now put double quotes around keywords. More accuracy but DRASTICALLY reduced volume.
		If you disallow links - email addresses will now also be removed
		Increased number of content grab tries to 7 per run.
		Improved ALL content sources (collection, verification, formatting etc)

Version 1.5.8 - 21st March 2010
		Removed ini_set for memory_limit as some hosts die when you set it
		Enabled ad rotation for html ad blocks
		Category creation function now makes first letter of words upper-case
		Fixed a bug that blocked cron from running!

Version 1.5.7 - 21st March 2010
		Added tweak to not block admin when WP user details not present (?)
		Swapped db tables to utf8 allowing for Chinese chars etc

Version 1.5.6 - 20th March 2010
		Fixed tweeting for manual posts bug
		Tweaked demo post time restrictions

Version 1.5.5 - 17th March 2010
		Swapped JS load order to help avoid conflicts with other plugins
		Fixed plugin run timing on some setups
		Fixed slashes before quotes in content block keywords
		
Version 1.5.4 - 17th March 2010
		CTR added to ad cache
		Affiliate Tab added
		Mass category creator added
		Added "delete all" for content blocks
		Removed FULLTEXT mysql fields as some DB types don't support them
		Listed all server IP's under "random IP" in "General Settings"
		Added auto removal of Twitter accounts for other circumstances
		Tweets will now be made for: scheduled posts (when they go live), drafts that later get published and Auto Estore posts.
		Added import & export options for speedy blog setups.
		The plugin dashboard is now blocked to all non-admin users... unless the username is: wptb
		Stopped www and non-www counting as 2 blogs on licence
		Made image names more unique to stop same second overwirtes :)
		Fixed "Invalid argument supplied for foreach line 214" using ad widget when so ads registered.
		Added support for proxies with auth + checkbox for SOCKS5
		Added live links to docs throughout plugin

Version 1.5.3 - 5th March 2010
		Fix a "timekey error" on some servers when using instant links
		"Delete Ad Cache" button didn't work. Now it does.
		Added in-post debugging info. Only blog admins can see this.

Version 1.5.2 - 3nd March 2010
		trim() all the user input (thought I did this already...)
		Fixed a bug and improved handling and feedback of RSS content
		Minified the admin css

Version 1.5.1 - 2nd March 2010
		Auto removed spaces from licence key when activating
		Fixed ad rule category bug resulting in no-show for category placements
		Moved the compatibility check to *above* the licence verification for ease of debugging
		Re-jigged some code for smoother processing (to avoid "ERROR: Unlock time key...")
		added install instructions as .txt
		
Version 1.5 - 2nd March 2010
		Added a check for no "wp-content/uploads" dir
		Fix a rare issue that would mangle some include paths if certain plugin combinations were in play.
		Fixed an error when no cached ads were present
		Stopped applying a f*#!ing frame breaker to the WP media upload box that was causing the "blank page" error.
		Added a "click to fix" link when the "db tables not created" error appears
		Setup the OPT_SLAVE to optimize your database for high post loads
		Added the Twitter account checker to the bonus tools section
		used trim() for a couple extra admin options to help avoid problems
		Follows weren't being made for RSS based content. Now they are.
		Fixed the issue where a random content block's details would be loaded to edit.
		Increased the php mem limit
		show specifc category in created content blocks if "All Posts In One Category" is chosen
		If post image is 75%+ of the max-width then display:block; so the text looks pretty
		Option to add all posts to DB as "draft"
		only post MAX once every 60 seconds to prevent madness
		Show plugin version in dashboard
		Make JS function names more unique to hopefully work with flexsqueeze theme.
		There's a plugin var conflict that stops tweeting on some systems. Make tweet vars more unique to (hopefully) fix.
		Replace file_get_contents with curl and fopen to circumvent non-allow_url_fopen support
		Add a check to see if the plugin was uploaded incorrectly (check is "wp-content/plugins/wtb_go.php" exisits)
		Silenced set_time_limit() to suppress errors on systems where this function is disabled! (777)
		Apply dupe post title check to RSS feeds as well
		Patched a PHP getimagesize bug so jpg files are read correctly
		RSS feeds weren't shown in the edit dialog box. Now they are.
		Added the Test Center with "Test Extractions"
		Create a cache viewing table of the DB in a popop
		Some meta is now attached to each post to improve ad accuracy
		Added double protection against blank posts
		Fix ClickBank product collector (regex broke)
		Create a "keyword ad test" popup to see what ads are returned (in test center)
		Fixed adsense (and sometimes html) not showing up for ad blocks feature
		Fully cloaked the ad click redirect to remove all mention of "WPTB" etc. It's now completly slient and faster.
		Option added (in general settings) to extract full RSS content instead of simply what you're given.
		Silenced CURLOPT_FOLLOWLOCATION to helpout safe mode (although safe mode still shouldn't be on)
		Add target=blank to outgoing "apply for aff account" links
		Fix a couple of bugs where variables were shuffle()'d
		Extensive licence system updates
		Transparent flash added so popups say *on-top-of* the flash vids 

Version 1.5_beta - 20th January 2010
		Made category dropdown show hidden categories
		Fixed frame breaker option not updating
		Check if all tables were created, and show error if not
		Image name tweak for added stability
		Fixed RSS feed posting (logic error)
		Added a php version check
		Check is upload directory is writeable in dash
		Adblocks feature (clickbank, adsense, amazon, ebay, plain html)
		Added ad impression and click tracking (and cloaking of affiliate links)
		Fixed all settings links going to WTB
		Block ads where title has only one word (no spaces) as they are spammy
		Added allow_url_fopen checking
		Keyword blacklist
		Add uploaded images to the WP Gallery
		Add post image resizing based on a max width
		Fixed issue that de-duped html code
		Added a WP version check
		Blocked full html pages from being posted due to a (currently unknown) bug
		Editable Content blocks
		make the licence key editable
		Added "clear tracking data" and "delete ad cache" buttons
		Poor content warnings now get entered in the log
		fix custom keywords not correct for content blocks
		Plugin folder name detection from external files (for added portability)
		Add a "skip this add" popup placement option for the ad blocks.
		Fixed formatting issue with email reports
		Used a "fake" cron to setup initial DB tables as WP didn't like what I was doing.

Version 1.4.1 - 11th January 2010
        Fixed tabs not expanding bug (plugin conflict)
        Fixed redirect for help links
        Altered proxy usage logic to fix small bug
        Added settings link to plugin activation page
        "last run" and "total runs" now increment for content blocks
        Fixed bug preventing posting to specific category
        Added a "clear log" button
        "Tweet too short" bug fixed (was a plugin variable conflict)
        Added error message when plugin folder is incorrectly named (temp fix)

Version 1.4 - 9th January 2010
        strip shorthand html ents from tweets - &apos;
        block too-short tweets and show message
        Plugin footer added
        WTB dashboard widget added
        Content blocks added for finer post control
        Limit external tweets to one every 60 seconds
        Add error check for no curl
        Improve account-removal error handling - only removed suspended accounts and incorrect login details
        Specific Tweet error log added
        Add frame breaker checkbox
        unfollow 10 non-mutuals when twitter limits imposed
        support for php without mb_convert_encoding
        index management improvements
        Stats added for backlinks, indexation, pagerank as well as tweet, post and follow figures.
        Use formatting on RSS content
        Clear the log every 24 hours ... even if email reports not set
        Better randomization of Twitter accounts
        activation stats setup

Version 1.3 - 5th December 2009
        Couple more small bugfixes
        New admin visuals
        Demo post lightbox
        Tips in header
        Logo tweaks
        IM_SLAVE bug fixed

Version 1.2.4 - 4th December 2009
        Dreamhost instant links fix
        Dreamhost css fix
        IE css fix
        External Post tweeting fix
        Fix for checkbox updating on some systems
        Added Quick start panel
        Option to disable background processing
        Licence info box added
        Inline support box
        Increased compatibility for certain systems

Version 1.2 - 3th December 2009
        Now plays nice with Thesis theme
        Updates to the licensing system
        Proxy rotator (currently http proxies with no auth)
        IP Randomizer
        Multiple content sources (G news, G blog search, Y! news, Y! answers, article dirs & Digg)
        Index Management feature
        Instant links getter button
        Keyword ideas w/ 1 click add
        Feed finder w/ 1 click add
        Improvements to the demo post system
        Bug fixes on the post tags & category selection
        Cron system rewrite
        English / All languages filter
        Can now tweet all posts to blog
        RSS feed posting now available
        Activity log added
        Big code cleanup and multiple touchups

Version 1.1 - 17th November 2009
        DeDupe checkbox added for unique content
        Better email report styling
        Email report dropdown bux fix
        
Version 1.0 - 16th November 2009
        First release! w00t!



*/




// kill the script for direct loads
if ( !function_exists( "update_option" ) )  die('omg l33t haxor!!!1!');

// uncomment this next line to increase the memory limit to 64M
//ini_set("memory_limit","64M");

// debugging
//ini_set("display_errors", 1);
//error_reporting(E_ALL|E_STRICT); // show all errors
//@error_reporting(E_ERROR | E_WARNING | E_PARSE); // only show runtime errors


// define some useful constants
define( "WTB_VERSION", "1.6.9.6" );
define( "WTB_BASE", get_option("siteurl") );
define( "WTB_WP_ADMIN", WTB_BASE."/wp-admin/" );
define( "WTB_FOL", trim( dirname( plugin_basename( __FILE__ ) ) ) );
define( "WTB_PATH", ABSPATH.PLUGINDIR."/".WTB_FOL );
define( "WTB_URL", WP_PLUGIN_URL."/".WTB_FOL );
define( "WTB_SUPPORT_URL", "http://codex.bz/support/" );
define( "WTB_COOKIE", WTB_PATH."/tmp/cookie.txt" );
define( "WTB_HTML_ERROR_LOG", WTB_PATH."/tmp/html_error_log.txt" );
define( "WTB_ADMIN_URL", WTB_BASE."/wp-admin/options-general.php?page=WpTweetBomb" );
define( "WTB_DASH", WTB_BASE."/wp-admin/options-general.php?page=WpTweetBomb" );
define( "WTB_CRON_URL", WTB_URL."/wtb_go.php" );

// gracefull Ioncube error handling
if( !isset($_GET['noIonError']) && !extension_loaded('ionCube Loader') ) {
	// only show nasty error message in WP admin (not on front end)
	if( is_admin() ) echo '<div><h1>Ioncube not found!</h1><p>WPTB requires ioncube to be installed on your server. Ask your host to install "ioncube loaders" for you and WPTB will work :)</p><p><strong><a href="'.WTB_WP_ADMIN.'">Go back to WordPress dashboard</a></strong></p><p><strong><a href="'.WTB_SUPPORT_URL.'">Visit the support forum</a></strong></p></div>';
}

// If we're good, include the config which kicks starts the plugin
else {
	require_once WTB_PATH."/wtb_config.php";
}


?>